## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

# Generated by go2rpm 1
# Disable check since checking needs 
# docker daemon and network to work
%bcond_with check
%global build_timestamp %(date +"%Y%m%d")

# https://github.com/Dreamacro/clash
%global goipath         github.com/Dreamacro/clash
Version:                1.8.0

%gometa

%global common_description %{expand:
A rule-based tunnel in Go.}

%global golicenses      LICENSE
%global godocs          docs README.md

Name:           clash
Release:        %autorelease
Summary:        A rule-based tunnel in Go

License:        GPLv3
URL:            %{gourl}
Source0:        %{gosource}
Source1:        clash.service
Source2:        clash@.service

BuildRequires:  systemd-rpm-macros

BuildRequires:  golang(github.com/Dreamacro/go-shadowsocks2/core)
BuildRequires:  golang(github.com/Dreamacro/go-shadowsocks2/shadowaead)
BuildRequires:  golang(github.com/Dreamacro/go-shadowsocks2/shadowstream)
BuildRequires:  golang(github.com/go-chi/chi/v5)
BuildRequires:  golang(github.com/go-chi/cors)
BuildRequires:  golang(github.com/go-chi/render)
BuildRequires:  golang(github.com/gofrs/uuid)
BuildRequires:  golang(github.com/gorilla/websocket)
BuildRequires:  golang(github.com/insomniacslk/dhcp/dhcpv4)
BuildRequires:  golang(github.com/miekg/dns)
BuildRequires:  golang(github.com/oschwald/geoip2-golang)
BuildRequires:  golang(github.com/sirupsen/logrus)
BuildRequires:  golang(go.etcd.io/bbolt)
BuildRequires:  golang(go.uber.org/atomic)
BuildRequires:  golang(go.uber.org/automaxprocs/maxprocs)
BuildRequires:  golang(golang.org/x/crypto/argon2)
BuildRequires:  golang(golang.org/x/crypto/chacha20poly1305)
BuildRequires:  golang(golang.org/x/net/http2)
BuildRequires:  golang(golang.org/x/net/publicsuffix)
BuildRequires:  golang(golang.org/x/sync/singleflight)
BuildRequires:  golang(golang.org/x/sys/unix)
BuildRequires:  golang(gopkg.in/yaml.v2)

%if %{with check}
# Tests
BuildRequires:  golang(github.com/docker/docker/api/types)
BuildRequires:  golang(github.com/docker/docker/api/types/container)
BuildRequires:  golang(github.com/docker/docker/client)
BuildRequires:  golang(github.com/docker/go-connections/nat)
BuildRequires:  golang(github.com/stretchr/testify/assert)
%endif


%description
%{common_description}

%gopkg

%prep
%goprep
chmod -x docs/logo.png

%build
export LDFLAGS="-X github.com/Dreamacro/clash/constant.Version=%{version} \
                -X github.com/Dreamacro/clash/constant.BuildTime=%{build_timestamp} \
                $LDFLAGS"
%gobuild -o %{gobuilddir}/bin/clash %{goipath}

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vd                     %{buildroot}%{_userunitdir}
install -m 0755 -vd                     %{buildroot}%{_unitdir}

install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/
install -m 0755 -vp %{S:1}              %{buildroot}%{_userunitdir}/
install -m 0755 -vp %{S:2}              %{buildroot}%{_unitdir}/

%if %{with check}
%check
%gocheck
%endif

%post
%systemd_user_post clash.service
%systemd_post clash@.service

%preun
%systemd_user_preun clash.service
# disable --now seems don't work here.
if [ $1 -eq 0 ] && [ -x /usr/bin/systemctl ] ; then
        # Package removal, not upgrade
        /usr/bin/systemctl --no-reload stop clash@*.service || :
        /usr/bin/systemctl --no-reload disable clash@.service || :
fi

%postun
%systemd_user_postun_with_restart clash.service
%systemd_postun_with_restart clash@*.service

%files
%license LICENSE
%doc docs README.md
%{_bindir}/clash
%{_userunitdir}/clash.service
%{_unitdir}/clash@.service
%gopkgfiles

%changelog
* 二 11月 09 2021 Qiyu Yan <yanqiyu@fedoraproject.org> 1.8.0-1
- Uncommitted changes

* 三 7月 21 2021 Fedora Release Engineering <releng@fedoraproject.org> 1.6.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* 三 7月 21 2021 Fedora Release Engineering <releng@fedoraproject.org> 1.6.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* 六 7月 03 2021 Qiyu Yan <yanqiyu@fedoraproject.org> 1.6.5-1
- Update to 1.6.5 (#1978923)

* 六 6月 12 2021 Qiyu Yan <yanqiyu@fedoraproject.org> 1.6.0-1
- Update to 1.6.0 upstream release

* 二 4月 13 2021 Qiyu Yan <yanqiyu@fedoraproject.org> 1.5.0-1
- Update to 1.5.0 upstream release

* 六 4月 03 2021 Qiyu Yan <yanqiyu@fedoraproject.org> 1.4.2-1
- Update to 1.4.2 upstream release

* 二 3月 02 2021 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> 1.2.0-3
- Rebuilt for updated systemd-rpm-macros

* 二 1月 26 2021 Fedora Release Engineering <releng@fedoraproject.org> 1.2.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* 五 10月 09 2020 Qiyu Yan <yanqiyu@fedoraproject.org> 1.2.0-1
- update to 1.2.0 upstream release

* 二 8月 18 2020 Qiyu Yan <yanqiyu@fedoraproject.org> 1.1.0-1
- update to 1.1.0 upstream release

* 四 8月 06 2020 Qiyu Yan <yanqiyu@fedoraproject.org> 1.0.0-1
- Initial Import#(1862660)
